import 'package:firebase_core/firebase_core.dart';
import 'package:flutter_firecache/flutter_firecache.dart';

class FirebaseProvider {
  final _db = Firebase.app();

  late FirestoreWrapper<CollectionPaths, DocumentPaths> db;
  late FirebaseClient<CollectionPaths, DocumentPaths> app;

  FirebaseProvider() {
    this.app = FirebaseClient(_db);
    this.db = this.app.db;
  }

  void patchState(RootStateObject state) {
    this.app.patchRootState(state.toJson());
  }
}

class RootStateObject implements StateBase {
  String userId;

  RootStateObject({required this.userId});

  factory RootStateObject.blank() {
    return RootStateObject(userId: '');
  }

  @override
  Map<String, dynamic> toJson() {
    return {
      'userId': this.userId,
    };
  }
}

class CollectionPaths {
  static const UserTasks = 'users/{{userId}}/tasks';
}

class DocumentPaths {
  static const CurrentUser = 'users/{{userId}}';
}
