import 'package:cloud_firestore/cloud_firestore.dart';

import '../query_state.dart';

Future<void> collectionCommandUpdate(
    QueryState q, String id, Map<String, dynamic> obj,
    [isMerged = true]) async {
  final collection = await q.refCollection().first;
  q.setUpdatedProps(obj, q.uid);
  try {
    return collection.doc(id).set(obj, SetOptions(merge: isMerged));
  } catch (e) {
    throw Exception(e);
  }
}

Future<DocumentReference> collectionCommandAdd(
  QueryState q,
  Map<String, dynamic> obj,
) async {
  final uid = q.uid;
  q.setUpdatedProps(obj, uid);
  q.setCreatedProps(obj, uid);
  final collection = await q.refCollection().first;
  try {
    final ref = await collection.add(obj);
    return ref;
  } catch (e) {
    throw Exception(e);
  }
}

Future<void> collectionCommandDelete(
  QueryState q,
  String id,
) async {
  final collection = await q.refCollection().first;
  try {
    await collection.doc(id).delete();
  } catch (e) {
    throw Exception(e);
  }
}
