import '../query_state.dart';

Stream<String> resolvePathVariables(QueryState q) {
  final $rootState = q.appState$.$all();
  var pathTemplate = q.pathTemplate;
  final inputOverridenState = q.overridenState;

  if (pathTemplate.isEmpty) {
    print("pathTemplate was not found: $pathTemplate");
    throw Exception('pathTemplate was not found');
  }

  final overridenState = inputOverridenState ?? {};

  final $rootStateOverriden = $rootState.map((r) {
    return {...r, ...overridenState};
  });

  final $pathResolved = $rootStateOverriden.map((r) {
    final state = r;
    for (var e in state.entries) {
      final match = '{{${e.key}}}';
      if (e.value is String) {
        pathTemplate = pathTemplate.replaceAll(match, e.value);
      }
    }
    if (pathTemplate.contains(RegExp(r'(?<=\{\{).*(?=\}\})'))) {
      final indexStart = pathTemplate.indexOf('{{');
      final indexEnd = pathTemplate.indexOf('}}') + 2;
      final field = pathTemplate.substring(indexStart, indexEnd);
      print('$field is not included in the state');
      throw Exception('Path error');
    }
    return pathTemplate;
  }).distinct();

  return $pathResolved;
}
